﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;
using System.Data;
using System.Collections;
using System.IO;
using System.Text;
using System.Web.UI.HtmlControls;
using System.Reflection;
using System.Data.Common;
using System.Configuration;
using System.Data.SqlClient;
using Telerik.Web.UI.GridExcelBuilder;
public partial class _Default : System.Web.UI.Page
{
    protected void Button1_Click(object sender, EventArgs e)
    {
        RadGrid1.MasterTableView.ExportToExcel();
    }
    protected void RadGrid1_NeedDataSource(object source, GridNeedDataSourceEventArgs e)
    {
        DataTable table = new DataTable();
        table.Columns.Add("ID", typeof(int));
        table.Columns.Add("Name");
        for (int i = 0; i < 10; i++)
            table.Rows.Add(i, "Number:" + i);
        RadGrid1.DataSource = table;
    }

    protected void RadGrid1_ExcelMLExportRowCreated(object source, GridExportExcelMLRowCreatedArgs e)
    {
        if (e.RowType == GridExportExcelMLRowType.HeaderRow)
        {
            RadGrid1.Rebind();  //workaround to get the template column's content

            //create new column element and a header cell
            e.Worksheet.Table.Columns.Add(new ColumnElement());
            CellElement cell = new CellElement();

            //correct the autofilter 
            e.Worksheet.AutoFilter.Range = String.Format("R{0}C{1}:R{0}C{2}", 1, 1, e.Worksheet.Table.Columns.Count + 1);

            //populate the header cell
            cell.Data.DataItem = (RadGrid1.MasterTableView.GetItems(GridItemType.Header)[0] as GridHeaderItem)["Name"].Text.Trim();
            e.Row.Cells.Add(cell);
        }

        if (e.RowType == GridExportExcelMLRowType.DataRow)
        {
            //create cell for the current row
            CellElement cell = new CellElement();
            int currentRow = e.Worksheet.Table.Rows.IndexOf(e.Row) - 1;

            //populate the data cell 
            cell.Data.DataItem = RadGrid1.MasterTableView.Items[currentRow]["Name"].Text;
            e.Row.Cells.Add(cell);
        }
    }
}